/***************************************************************************
  graindb.h
  -------------------
  A dialog page for grains
  -------------------
  Copyright 2005, David Johnson
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ***************************************************************************/

#ifndef GRAINDB_H
#define GRAINDB_H

#include "grainview.h"
#include "grain.h"

class Model;

class GrainDB : public GrainView  {
    Q_OBJECT
public:
    // constructor
    GrainDB(QWidget *parent, const char *name, Model *model);
    // destructor
    virtual ~GrainDB();

    // initialize list and fields
    void refresh();

signals:
    // emits on modification
    void modified();

private slots:
    // add a grain
    void addGrain();
    // remove a grain
    void removeGrain();
    // apply / change a grain
    void applyGrain();
    // update the entry fields
    void updateFields(const QString &name);
    // an ingredient was selected
    void itemSelected(QListViewItem *item);

private:
    Model *model_;
    GrainItem* currentitem_;
};

#endif // GRAINDB_H
